//----------------------------------------------------------------------//
// \\															//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include <System.StrUtils.hpp>
#include "usr_str.h"
#include "usr_file_ex.h"
#include "usr_highlight.h"

//---------------------------------------------------------------------------
//gqɑ΂Rgʕ擾
//---------------------------------------------------------------------------
bool GetCommentList(
	UnicodeString fnam,		//t@C
	TStringList *ln_lst,	//PsRg
	TStringList *bgn_lst,	//ubNJn
	TStringList *end_lst,	//ubNI
	bool en_html)			//HTMLL (default = true)
{
	if (fnam.IsEmpty()) return false;

	UnicodeString fext = get_extension(fnam);

	if (test_FileExt(fext, FEXT_NRM_REM)) {
		ln_lst->Add("//");
		bgn_lst->Add("/*");	end_lst->Add("*/");
	}
	else if (test_FileExt(fext, FEXT_SMCL_REM)) {
		ln_lst->Add(";");
	}
	else if (test_FileExt(fext, FEXT_PASCAL)) {
		ln_lst->Add("//");
		bgn_lst->Add("{");	end_lst->Add("}");
		bgn_lst->Add("(*");	end_lst->Add("*)");
	}
	//
	else if (test_FileExt(fext, _T(".ahk"))) {
		ln_lst->Add(";");
		bgn_lst->Add("/*");	end_lst->Add("*/");
	}
	else if (test_FileExt(fext, _T(".au3"))) {
		ln_lst->Add(";");
		bgn_lst->Add("#comments-start");	end_lst->Add("#comments-end");
		bgn_lst->Add("#cs");	end_lst->Add("#ce");
	}
	else if (test_FileExt(fext, _T(".awk.pl.pm.sh"))) {
		ln_lst->Add("#");
	}
	else if (test_FileExt(fext, _T(".bat.cmd"))) {
		ln_lst->Add("@REM");
		ln_lst->Add("REM");
		ln_lst->Add("::");
	}
	else if (test_FileExt(fext, _T(".css.drc"))) {
		bgn_lst->Add("/*");	end_lst->Add("*/");
	}
	else if (test_FileExt(fext, _T(".fs"))) {
		ln_lst->Add("//");
		bgn_lst->Add("(*");	end_lst->Add("*)");
	}
	else if (test_FileExt(fext, _T(".hs"))) {
		ln_lst->Add("--");
		bgn_lst->Add("{-");	end_lst->Add("-}");
	}
	else if (test_FileExt(fext, _T(".lisp.lsp"))) {
		ln_lst->Add(";");
		bgn_lst->Add("#|");	end_lst->Add("|#");
	}
	else if (test_FileExt(fext, _T(".lua"))) {
		ln_lst->Add("--");
	}
	else if (test_FileExt(fext, _T(".m"))) {
		ln_lst->Add("%");
		bgn_lst->Add("%{");	end_lst->Add("%}");
	}
	else if (test_FileExt(fext, _T(".rb"))) {
		ln_lst->Add("#");
		bgn_lst->Add("=begin");	end_lst->Add("=end");
	}
	else if (test_FileExt(fext, _T(".sql"))) {
		ln_lst->Add("--");
		bgn_lst->Add("/*");	end_lst->Add("*/");
	}
	else if (test_FileExt(fext, _T(".bas.vb.vbs.mac"))) {
		ln_lst->Add("'");
	}
	else if (test_FileExt(fext, _T(".php"))) {
		ln_lst->Add("//");
		ln_lst->Add("#");
		bgn_lst->Add("/*");		end_lst->Add("*/");
		bgn_lst->Add("<!--");	end_lst->Add("-->");
	}
	else if (test_FileExt(fext, _T(".ps1.psm1"))) {
		ln_lst->Add("#");
		bgn_lst->Add("<#");	end_lst->Add("#>");
	}
	else if (test_FileExt(fext, _T(".py"))) {
		ln_lst->Add("#");
		bgn_lst->Add("\"\"\""); end_lst->Add("\"\"\"");
		bgn_lst->Add("\'\'\'"); end_lst->Add("\'\'\'");
	}
	else if (test_FileExt(fext, _T(".st"))) {
		bgn_lst->Add("\"");	end_lst->Add("\"");
	}
	else if (test_FileExt(fext, _T(".vhd"))) {
		ln_lst->Add("--");
	}
	//̑
	else if (test_FileExt(fext, _T(".dsp.dsw.nodoka.yml.yaml.PspScript"))) {
		ln_lst->Add("#");
	}
	else if (en_html && test_FileExt(fext, FEXT_HTML) || test_FileExt(fext, FEXT_XML)) {
		bgn_lst->Add("<!--");	end_lst->Add("-->");
	}
	else if (test_FileExt(fext, _T(".txt")) && USTARTS_TS("awstats", ExtractFileName(fnam))) {
		ln_lst->Add("#");
	}

	return (ln_lst->Count>0 || bgn_lst->Count>0 || end_lst->Count>0);
}

//---------------------------------------------------------------------------
//sŜRg?
//  Xg{bNXőOQƂă`FbN
//---------------------------------------------------------------------------
bool is_CommentLine(
	TListBox *lp,
	int idx,
	UnicodeString fnam)		//Rgpt@C
{
	bool flag = false;

	if (!fnam.IsEmpty()) {
		std::unique_ptr<TStringList> ln_lst(new TStringList());		//PsRg
		std::unique_ptr<TStringList> bg_lst(new TStringList());		//ubNJn
		std::unique_ptr<TStringList> ed_lst(new TStringList());		//ubNI
		GetCommentList(fnam, ln_lst.get(), bg_lst.get(), ed_lst.get());

		UnicodeString lbuf = Trim(lp->Items->Strings[idx]);

		for (int i=0; i<ln_lst->Count && !flag; i++)
			flag = StartsStr(ln_lst->Strings[i], lbuf);

		if (!flag) {
			for (int i=0; i<bg_lst->Count && !flag; i++) {
				UnicodeString bg_str = bg_lst->Strings[i];
				UnicodeString ed_str = ed_lst->Strings[i];
				bool is_same = SameStr(bg_str, ed_str);

				//ubNRg?
				if (!ContainsStr(lbuf, bg_str) && !ContainsStr(lbuf, ed_str)) {
					int range = 50;	//*** `FbN͈
					int idxj = idx - 1;
					//`FbN
					for (int j=0; j<range && !flag && idx>=0; j++,idxj--) {
						UnicodeString jbuf = Trim(lp->Items->Strings[idxj]);
						if (EndsStr(ed_str, jbuf)) break;
						if (StartsStr(bg_str, jbuf)) flag = true;
					}
					//`FbN
					if (flag) {
						flag = false;
						idxj = idx + 1;
						for (int j=0; j<range && !flag && idxj<lp->Count; j++,idxj++) {
							UnicodeString jbuf = Trim(lp->Items->Strings[idxj]);
							if (!is_same && StartsStr(bg_str, jbuf)) break;
							if (EndsStr(ed_str, jbuf)) flag = true;
						}
					}
				}
				//ubNRgJns?
				else if (remove_top_s(lbuf, bg_str))
					flag = EndsStr(ed_str, lbuf) || !ContainsStr(lbuf, ed_str);
				//ubNRgIs?
				else if (remove_end_s(lbuf, ed_str))
					flag = StartsStr(bg_str, lbuf) || !ContainsStr(lbuf, bg_str);
			}
		}
	}

	return flag;
}

//---------------------------------------------------------------------------
//gqɑ΂\p^[擾
//---------------------------------------------------------------------------
UnicodeString GetReservedPtn(
	UnicodeString fext,		//gq
	bool &sns_case, 		//召
	bool is_xml,			//ΏۂXML
	bool isHtm2Txt)			//HTMLTEXTϊ
{
	UnicodeString ret_str;

	if (is_xml) {
		ret_str.USET_T("<[^<>]+(>|\\s)");
		sns_case = false;
	}
	else if (test_FileExt(fext, _T(".ahk"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(gosub|goto|if|else|loop)\\b|")
			_T("^\\s*#\\w+\\b"));
	}
	else if (test_FileExt(fext, _T(".as"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(as|break|case|catch|class|const|continue|default|delete|do|else|extends|false|")
			_T("finally|for|function|if|implements|import|in|instanceof|interface|internal|is|native|")
			_T("new|null|package|private|protected|public|return|super|switch|this|throw|to|true|try|")
			_T("typeof|use|var|void|while|with)\\b"));
	}
	else if (test_FileExt(fext, _T(".au3"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(ContinuelOop|Dim|Global|Local|Const|Do|Until|Exit|Exitloop|For|Next|Func|Return|")
			_T("Endfunc|If|Then|Elseif|Else|Endif|Redim|Select|Case|Endselect|While|Wend)\\b|")
			_T("^\\s*#\\w+\\b"));
		sns_case = false;
	}
	else if (test_FileExt(fext, _T(".awk"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(BEGIN|break|close|continue|delete|do|else|END|exit|for|function|getline|gsub|if|index|")
			_T("length|match|next|print|printf|return|split|sprintf|sub|substr|system|tolower|toupper|while)\\b"));
	}
	else if (test_FileExt(fext, _T(".bat.cmd.qbt"))) {
		ret_str.USET_T("(@|\\b)(call|cls|cmd|echo|errorlevel|exit|for|goto|if|pause|rem|set|shift|start)\\b");
		sns_case = false;
	}
	else if (test_FileExt(fext, _T(".cs"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(abstract|as|async|await|base|bool|break|byte|case|catch|char|checked|class|")
			_T("const|continue|decimal|default|delegate|do|double|else|enum|event|explicit|extern|")
			_T("false|finally|fixed|float|for|foreach|goto|if|implicit|in|int|interface|internal|")
			_T("is|lock|long|namespace|new|null|object|operator|out|override|params|private|protected|")
			_T("public|readonly|ref|return|sbyte|sealed|short|sizeof|stackalloc|static|string|struct|")
			_T("switch|this|throw|true|try|typeof|uint|ulong|unchecked|unsafe|ushort|using|virtual|")
			_T("volatile|void|while)\\b|")
			_T("^\\s*#\\w+\\b"));
	}
	else if (test_FileExt(fext, FEXT_C_SH _T(".d.idl"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(alignas|alignof|asm|_asm|__asm|auto|_automated|axiom|_Bool|bool|false|true|")
			_T("break|case|catch|cdecl|_cdecl|__cdecl|char|char(16|32)_t|class|__classid|__classmethod|")
			_T("__closure|_Complex|concept|concept_map|const|const_cast|constexpr|continue|__declspec|")
			_T("decltype|default|delete|__delphirtti|deprecated|__dispid|do|double|dynamic_cast|")
			_T("enum|__except|explicit|export|_export|__export|extern|_fastcall|__fastcall|final|")
			_T("__finally|float|for|friend|goto|if|else|_Imaginary|_import|__import|inline|__inline|")
			_T("int|__int(8|16|32|64)|late_check|long|__msfastcall|__msreturn|mutable|namespace|")
			_T("new|noreturn|nullptr|operator|pascal|_pascal|__pascal|private|__property|protected|")
			_T("public|__published|register|reinterpret_cast|requires|restrict|return|__rtti|short|")
			_T("signed|sizeof|static|static_assert|static_cast|_stdcall|__stdcall|struct|switch|")
			_T("template|this|thread_local|__thread|throw|try|__try|typedef|typeid|typename|union|")
			_T("unsigned|using|virtual|void|volatile|wchar_t|while)\\b|")
			_T("^\\s*#\\w+\\b"));
	}
	else if (test_FileExt(fext, _T(".dsp"))) {
		ret_str.USET_T("^!\\w+\\b");
	}
	else if (test_FileExt(fext, _T(".eml"))) {
		ret_str.USET_T("^(Bcc|Cc|Date|From|Subject|To):");
		sns_case = false;
	}
	else if (test_FileExt(fext, _T(".fs"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(abstract|and|as|asr|assert|base|begin|class|default|delegate|do|done|downcast|")
			_T("downto|elif|else|end|exception|extern|false|finally|for|fun|function|global|if|")
			_T("in|inherit|inline|interface|internal|land|lazy|let|let!|lor|lsl|lsr|lxor|match|")
			_T("member|mod|module|mutable|namespace|new|not|null|of|open|or|override|private|public|")
			_T("rec|return!?|select|sig|static|struct|then|to|try|type|upcast|use!?|val|void|when|")
			_T("while|with|yield!?)\\b|")
			_T("^\\s*#\\w+\\b"));
	}
	else if (test_FileExt(fext, _T(".go"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(break|case|chan|const|continue|default|defer|else|fallthrough|for|func|go|goto|")
			_T("if|import|interface|map|package|range|return|select|struct|switch|type|var)\\b"));
	}
	else if (test_FileExt(fext, _T(".hs"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(as|case|of|class|data|default|deriving|do|forall|foreign|hiding|if|then|else|")
			_T("import|infix|infixl|infixr|instance|let|in|mdo|module|newtype|qualified|type|where)\\b"));
	}
	else if (test_FileExt(fext, _T(".hsp"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(await|break|continue|else|end|exec|exgoto|foreach|gosub|goto|if|loop|on|onclick|")
			_T("oncmd|onerror|onexit|onkey|repeat|return|run|stop|wait|array|double|int|str|var)\\b|")
			_T("^\\s*#\\w+\\b"));
	}
	else if (test_FileExt(fext, _T(".js.jsx"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(abstract|boolean|break|byte|case|catch|char|class|const|continue|default|do|")
			_T("double|else|extends|false|final|finally|float|for|function|goto|if|implements|import|")
			_T("in|instanceof|int|interface|long|native|new|null|package|private|protected|public|")
			_T("return|short|static|super|switch|synchronized|this|throw|throws|transient|true|")
			_T("try|typeof|var|void|while|with)\\b"));
	}
	else if (test_FileExt(fext, _T(".java"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(abstract|assert|boolean|break|byte|case|catch|char|class|const|continue|default|")
			_T("do|double|else|enum|extends|final|finally|float|for|goto|if|implements|import|instanceof|")
			_T("int|interface|long|native|new|package|private|protected|public|return|short|static|")
			_T("strictfp|super|switch|synchrnized|this|throw|throws|transient|try|void|volatile|while)\\b"));
	}
	else if (test_FileExt(fext, _T(".json"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(true|false|null)\\b"));
	}
	else if (test_FileExt(fext, _T(".kt.kts"))) {
		ret_str.sprintf(_T("%s"),
			//Hard
			_T("\\b(as|break|class|continue|do|else|false|for|fun|if|in|interface|is|null|object|package|")
			_T("return|super|this|throw|true|try|typealias|typeof|val|var|when|while|")
			//Soft
			_T("by|catch|constructor|delegate|dynamic|field|file|finally|get|import|init|param|property|")
			_T("receiver|set|setparam|where)\\b|")
			//Modifier
			_T("\\b(actual|abstract|annotation|companion|const|crossinline|data|enum|expect|external|final|")
			_T("infix|inline|inner|internal|lateinit|noinline|open|operator|out|override|private|")
			_T("protected|public|reified|sealed|suspend|tailrec|vararg)\\s"));
	}
	else if (test_FileExt(fext, _T(".lua"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(and|break|do|else|elseif|end|false|for|function|if|in|local|nil|not|or|repeat|")
			_T("return|then|true|until|while)\\b"));
	}
	else if (test_FileExt(fext, FEXT_PASCAL)) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(absolute|abstract|and|array|as|asm|assembler|at|automated|begin|case|cdecl|")
			_T("class|const|constructor|default|destructor|dispid|div|do|downto|dynamic|else|end|")
			_T("except|exports|external|file|finalization|finally|for|forward|function|goto|if|")
			_T("implementation|in|index|inherited|initialization|inline|interface|is|label|library|")
			_T("message|mod|name|nil|nodefault|not|object|of|on|or|override|packed|pascal|private|")
			_T("procedure|program|property|protected|public|published|raise|read|record|register|")
			_T("repeat|resident|set|shl|shr|stdcall|stored|string|then|threadvar|to|try|type|unit|")
			_T("until|uses|var|virtual|while|with|write|xor)\\b"));
		sns_case = false;
	}
	else if (test_FileExt(fext, _T(".php")) && !isHtm2Txt) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(abstract|and|array|as|break|case|catch|cfunction|class|clone|const|continue|")
			_T("declare|default|die|do|echo|else|elseif|empty|enddeclare|endfor|endforeach|endif|")
			_T("endswitch|endwhile|eval|exception|exit|extends|extends|final|for|foreach|function|")
			_T("global|if|implements|include|include_once|interface|isset|list|new|old_function|")
			_T("or|php_user_filter|php_user_filter|print|private|protected|public|require|require_once|")
			_T("return|static|switch|this|throw|try|unset|use|var|while|xor|__CLASS__|__FILE__|")
			_T("__FUNCTION__|__LINE__|__METHOD__)\\b"));
	}
	else if (test_FileExt(fext, _T(".pl.pm"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(abs|accept|alarm|and|atan2|bind|binmode|bless|caller|chdir|chmod|chomp|chop|")
			_T("chown|chr|chroot|close|closedir|cmp|connect|continue|cos|crypt|dbmclose|dbmopen|")
			_T("defined|delete|die|do|dump|each|else|elsif|endgrent|endhostent|endnetent|endprotoent|")
			_T("endpwent|endservent|eof|eq|eval|exec|exists|exit|exp|fcntl|fileno|flock|for|foreach|")
			_T("fork|formline|ge|getc|getgrent|getgrgid|getgrnam|gethostby(addr|name)|gethostent|")
			_T("getlogin|getnetby(addr|name)|getnetent|getpeername|getpgrp|getppid|getpriority|")
			_T("getprotobyname|getprotobynumber|getprotoent|getpwent|getpwnam|getpwuid|getservbyname|")
			_T("getservbyport|getservent|getsock(name|opt)|glob|gmtime|goto|grep|gt|hex|if|import|")
			_T("index|int|ioctl|join|keys|kill|last|lc|lcfirst|le|length|link|listen|local|localtime|")
			_T("log|lstat|lt|map|mkdir|msgctl|msgget|msgrcv|msgsnd|my|ne|next|no|not|oct|open|opendir|")
			_T("or|ord|pack|pipe|pop|pos|print|printf|push|quotemeta|rand|read|readdir|readlink|")
			_T("recv|redo|ref|rename|require|reset|return|reverse|rewinddir|rindex|rmdir|scalar|")
			_T("seek|seekdir|select|semctl|semget|semop|send|setgrent|sethostent|setnetent|setpgrp|")
			_T("setpriority|setprotoent|setpwent|setservent|setsockopt|shift|shmctl|shmget|shmread|")
			_T("shmwrite|shutdown|sin|sleep|socket|socketpair|sort|splice|split|sprintf|sqrt|srand|")
			_T("stat|study|sub|substr|symlink|syscall|sysread|system|syswrite|tell|telldir|tie|")
			_T("time|times|truncate|uc|ucfirst|umask|undef|unless|unlink|unpack|unshift|untie|use|")
			_T("utime|values|vec|wait|waitpid|wantarray|warn|while|write|xor)\\b"));
	}
	else if (test_FileExt(fext, _T(".py"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(access|and|break|class|continue|def|del|elif|else|expect|exec|finally|for|form|")
			_T("global|if|import|in|is|lambda|not|or|pass|print|raise|return|try|while)\\b"));
	}
	else if (test_FileExt(fext, _T(".ps1.psm1"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(Begin|Break|Catch|Class|Continue|Data|Define|Do|DynamicParam|Else|ElseIf|End|Exit|")
			_T("Filter|Finally|For|ForEach|From|Function|If|In|InlineScript|Parallel|Param|Process|")
			_T("Return|Sequence|Switch|Throw|Trap|Try|Until|Using|Var|While|Workflow)\\b"));
		sns_case = false;
	}
	else if (test_FileExt(fext, _T(".rb"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(BEGIN|END|alias|and|begin|break|case|class|def|defined|do|else|elsif|end|ensure|")
			_T("false|for|if|in|module|next|nil|not|or|redo|rescue|retry|return|self|super|then|")
			_T("true|undef|unless|until|when|while|yield)\\b"));
	}
	else if (test_FileExt(fext, _T(".rc.drc"))) {
		ret_str.USET_T("^\\s*#\\w+\\b");
	}
	else if (test_FileExt(fext, _T(".rs"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(abstract|alignof|as|become|box|break|const|continue|crate|do|else|enum|extern|")
			_T("false|final|fn|for|if|impl|in|let|loop|macro|match|mod|move|mut|offsetof|override|")
			_T("priv|proc|pub|pure|ref|return|Self|self|sizeof|static|struct|super|trait|true|type|")
			_T("typeof|unsafe|unsized|use|virtual|where|while|yiel)\\b"));
	}
	else if (test_FileExt(fext, _T(".scala"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(abstract|case|catch|class|def|do|else|extends|false|finalfinally|for|forSome|if|")
			_T("implicit|import|lazy|match|new|null|object|override|package|private|protected|requires|")
			_T("return|sealed|super|this|throw|trait|try|true|type|val|var|while|with|yield|_)\\b|=>|<:|<%|>:"));
	}
	else if (test_FileExt(fext, _T(".st"))) {
		ret_str.USET_T("\\b(self|super|nil|true|false|thisContext)\\b");
	}
	else if (test_FileExt(fext, _T(".swift"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(as|associativity|break|case|class|continue|default|deinit|didSet|do|dynamicType|")
			_T("else|enum|extension|fallthrough|for|func|get|if|import|in|infix|init|inout|is|left|")
			_T("let|mutating|new|none|nonmutating|operator|override|postfix|precedence|prefix|protocol|")
			_T("return|right|Self|self|set|static|struct|subscript|super|switch|Type|typealias|")
			_T("unowned|var|weak|where|while|willSet|__COLUMN__|__FILE__|__FUNCTION__|__LINE__)\\b"));
	}
	else if (test_FileExt(fext, _T(".sh"))) {
		ret_str.USET_T("\\b(case|in|esac|for|do|done|function|if|then|fi|elif|else|select|time|until|while)\\b");
	}
	else if (test_FileExt(fext, _T(".tex"))) {
		ret_str.USET_T("\\\\\\w+\\b");
	}
	else if (test_FileExt(fext, _T(".vb.bas"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(AddHandler|AddressOf|Alias|And|AndAlso|As|Boolean|ByRef|Byte|ByVal|Call|Case|")
			_T("Catch|CBool|CByte|CChar|CDate|CDec|CDbl|Char|CInt|Class|CLng|CObj|Const|Continue|")
			_T("CSByte|CShort|CSng|CStr|CType|CUInt|CULng|CUShort|Date|Decimal|Declare|Default|")
			_T("Delegate|Dim|DirectCast|Do|Double|Each|Else|ElseIf|End|EndIf|Enum|Erase|Error|Event|")
			_T("Exit|False|Finally|For|Friend|Function|Get|GetType|Global|GoSub|GoTo|Handles|If|")
			_T("Implements|Imports|In|Inherits|Integer|Interface|Is|IsNot|Let|Lib|Like|Long|Loop|")
			_T("Me|Mod|Module|MustInherit|MustOverride|MyBase|MyClass|Namespace|Narrowing|New|Next|")
			_T("Not|Nothing|NotInheritable|NotOverridable|Object|Of|On|Operator|Option|Optional|")
			_T("Or|OrElse|Overloads|Overridable|Overrides|ParamArray|Partial|Private|Property|Protected|")
			_T("Public|RaiseEvent|ReadOnly|ReDim|REM|RemoveHandler|Resume|Return|SByte|Select|Set|")
			_T("Shadows|Shared|Short|Single|Static|Step|Stop|String|Structure|Sub|SyncLock|Then|")
			_T("Throw|To|True|Try|TryCast|TypeOf|Variant|Wend|UInteger|ULong|UShort|Using|When|")
			_T("While|Widening|With|WithEvents|WriteOnly|Xor)\\b|(#(Const|Else|ElseIf|End|If))\\b"));
		sns_case = false;
	}
	else if (test_FileExt(fext, _T(".vbs.mac"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(And|As|Boolean|ByRef|Byte|ByVal|Call|Case|Class|Const|Currency|Debug|Dim|Do|")
			_T("Double|Each|Else|ElseIf|Empty|End|EndIf|Enum|Eqv|Event|Exit|False|For|Function|")
			_T("Get|GoTo|If|Imp|Implements|In|Integer|Is|Let|Like|Long|Loop|LSet|Me|Mod|New|Next|")
			_T("Not|Nothing|Null|On|Option|Optional|Or|ParamArray|Preserve|Private|Public|RaiseEvent|")
			_T("ReDim|Rem|Resume|RSet|Select|Set|Shared|Single|Static|Stop|Sub|Then|To|True|Type|")
			_T("TypeOf|Until|Variant|Wend|While|With|Xor)\\b"));
		sns_case = false;
	}
	else if (test_FileExt(fext, _T(".v"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(always|and|assign|begin|buf|bufif0|bufif1|case|casx|casez|cmos|deassign|default|")
			_T("defparam|disable|edge|else|end|endcase|endmodule|endfuncion|endprimitive|endspecify|")
			_T("endtable|endtask|event|for|force|forever|fork|function|highz0|highz1|if|ifnone|initial|")
			_T("inout|input|integer|join|large|macromodule|medium|module|nand|negedge|nmos|nor|not|")
			_T("notif0|notif1|output|parameter|pmos|posedge|primitive|pull0|pull1|pullup|pulldown|rcmos|")
			_T("real|realtime|reg|release|repeat|rnmos|rpmos|rtran|rtranif0|rtranif1|scalared|small|")
			_T("specify|specparam|strong0|strong1|supply0|supply1|table|task|time|tran|tranif0|tranif1|")
			_T("tri|tri0|tri1|triand|trior|trireg|vectored|wait|wand|weak0|weak1|while|wire|wor|xnor|xor)\\b|")
			_T("^\\s*`\\w+\\b"));
	}
	else if (test_FileExt(fext, _T(".vhd"))) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(abs|access|after|alias|all|and|architecture|array|assert|attribute|begin|block|")
			_T("body|buffer|bus|case|component|configuration|constant|disconnect|downto|else|elsif|")
			_T("end|entity|exit|file|for|function|generate|generic|group|guarded|if|impure|in|inertial|")
			_T("inout|is|label|library|linkage|literal|loop|map|mod|nand|new|next|nor|not|null|of|on|")
			_T("open|or|others|out|package|port|posponed|procedure|process|pure|range|record|register|")
			_T("reject|rem|report|return|rol|ror|select|severity|shared|signal|sla|sll|sra|srl|subtype|")
			_T("then|to|transport|type|unaffected|units|until|use|variable|wait|when|while|with|xnor|xor)\\b"));
	}
	else if (test_FileExt(fext, FEXT_HTML)) {
		if (isHtm2Txt)
			ret_str.USET_T("^(Description : |Title : )");
		else {
			ret_str.USET_T("<[^<>]+>");
			sns_case = false;
		}
	}
	else if (USAME_TI(fext, ".nbt")) {
		ret_str.sprintf(_T("%s"),
			_T("\\b(Add|(Append|Filter|Load|Replace|Save)Buffer|Break|CallCommands|Close|Continue|")
			_T("Debug|Download|Echo(On|Off|T?)|Else|End(If|Repeat)|Exit|FileExists|FlashWin|Format(DT|")
			_T("DI)?|Goto|Grep(SetMask|Start)|Hint|If[^_]*(_(Break|Continue|Exit||Goto))?|Input|")
			_T("Ins|JumpCommands|List(Buffer|Var)|Match(Buffer|Dir|Ext|Name)|MsgBox[YNC]*|MsgOff|")
			_T("Nop|PlaySound|PopupMenu|(Push|Pop)(Index|TopIndex|Var)|Random|ReadINI|Redraw|Repeat|ReturnCommands|")
			_T("SearchDown[FD]?|SearchUp[FD]?|SendCommands|Set_|Set(Clipboard|CopyMode|FileTime|")
			_T("Index)|SetExe(File|Param|Dir|Opt)|ShellExecute|Sleep|Test|Timer|WaitForTask2?|Warn|WriteINI)_?"));
		sns_case = false;
	}

	return ret_str;
}
//---------------------------------------------------------------------------
//gqɑ΂\p^[擾
//---------------------------------------------------------------------------
UnicodeString GetNumericPtn(
	UnicodeString fext)		//gq
{
	UnicodeString ret_str;

	if (test_FileExt(fext, _T(".css")))
		ret_str.USET_T("([: ]+#[0-9a-f]+)|(\\b[0-9][0-9.]*)");
	else if (test_FileExt(fext, _T(".dfm")))
		ret_str.USET_T("\\s[0-9]+\\b");
	else if (test_FileExt(fext, _T(".fs")))
		ret_str.USET_T("\\b[0-9][box0-9a-f.]*\\b");
	else if (test_FileExt(fext, _T(".json")))
		ret_str.USET_T("\\b-?[0-9][0-9.]*\\b");
	else if (test_FileExt(fext, _T(".swift")))
		ret_str.USET_T("\\b([0-9][0-9._]*(e[\\+\\-]?[0-9]+)?|0x[0-9a-f.]+(p[\\+\\-]?[0-9]+)?|0b[01]+|0o[0-7]+)\\b");
	else if (test_FileExt(fext, _T(".vb.vbs.bas.mac")))
		ret_str.USET_T("(\\b[0-9][0-9.]*\\b)|(&h[0-9a-f]+&?)");
	else if (test_FileExt(fext, _T(".v")))
		ret_str.USET_T("\\b[0-9]+('(b[01_]+|o[0-7_]+|d[0-9_]+|h[0-9a-f_]+))?");
	else if (test_FileExt(fext, FEXT_PASCAL))
		ret_str.USET_T("((\\b[0-9][0-9.]*)|(\\$[0-9a-f]+))\\b");
	else if (test_FileExt(fext, FEXT_PROGRAM))
		ret_str.USET_T("\\b[0-9][x0-9a-f.]*[ul]*\\b");
	else if (USAME_TI(fext, ".nbt"))
		ret_str.USET_T("\\b[0-9]+\\b");

	return ret_str;
}

//---------------------------------------------------------------------------
//gqɑ΂V{擾
//---------------------------------------------------------------------------
UnicodeString GetSymbolChars(
	UnicodeString fext,		//gq
	bool is_xml,			//ΏۂXML
	bool isHtm2Txt)			//HTMLTEXTϊ
{
	UnicodeString ret_str;

	if		(is_xml)									ret_str.USET_T("{}/=<>:;?");
	else if (test_FileExt(fext, _T(".au3")))			ret_str.USET_T("{}()[]+-*/%&!~=<>,.:");
	else if (test_FileExt(fext, _T(".css")))			ret_str.USET_T("{}()*:;");
	else if (test_FileExt(fext, _T(".dfm")))			ret_str.USET_T("()[]=");
	else if (test_FileExt(fext, _T(".dsp.dsw")))		ret_str.USET_T("{}/=<>:?");
	else if (test_FileExt(fext, _T(".json")))			ret_str.USET_T("{}[],:");
	else if (test_FileExt(fext, _T(".ps1.psm1")))		ret_str.USET_T("{}()[]+-*/%|=,:@");
	else if (test_FileExt(fext, _T(".vb.vbs.bas.mac")))	ret_str.USET_T("{}()[]+-*/%|^!~=<>,:;?");
	else if (test_FileExt(fext, _T(".vhd")))			ret_str.USET_T("{}()[]+-*/%&!=<>,:;");
	else if (test_FileExt(fext, FEXT_PROGRAM))			ret_str.USET_T("{}()[]+-*/%&|^!~=<>,:;?");
	else if (USAME_TI(fext, ".nbt"))					ret_str.USET_T("+-*/%!=<>#_");
	else if (test_FileExt(fext, FEXT_HTML)) {
		if (!isHtm2Txt) ret_str.USET_T("{}</>=:;");
	}

	return ret_str;
}

//---------------------------------------------------------------------------
//gqɑ΂镶p擾
//---------------------------------------------------------------------------
UnicodeString GetQuotChars(
	UnicodeString fext,		//gq
	bool &useEsc,			//[o] GXP[vV[PXL
	bool is_xml,			//ΏۂXML
	bool is_ini,			//ΏۂINIt@C
	bool isHtm2Txt)			//HTMLTEXTϊ
{
	UnicodeString ret_str;

	if (test_FileExt(fext,
		FEXT_C_SH _T(".ahk.awk.bas.bat.cbproj.cmd.cs.drc.dsp.dsw.fs.hs.hsp.idl.java.json.lisp.lsp.lua.mac.qbt.qml.rc.rs.scala.swift.vb.vbs.v.vhd")))
															ret_str.USET_T("\"");
	else if (test_FileExt(fext, FEXT_PASCAL _T(".dfm.st")))	ret_str.USET_T("\'");
	else if (test_FileExt(fext, _T(".php")) && !isHtm2Txt)	ret_str.USET_T("\"\'");
	else if (test_FileExt(fext, _T(".as.au3.css.js.jsx.kt.kts.pl.ps1.psm1.rb.py.sql.PspScript")))
															ret_str.USET_T("\"\'");
	else if (test_FileExt(fext, _T(".go")))					ret_str.USET_T("\"`");
	else if (test_FileExt(fext, _T(".sh")))					ret_str.USET_T("\"\'`");
	else if (test_FileExt(fext, FEXT_HTML) && !isHtm2Txt)	ret_str.USET_T("\"");
	else if (is_xml || is_ini)								ret_str.USET_T("\"");
	else if (USAME_TI(fext, ".nbt"))						ret_str.USET_T("\"%");

	useEsc = (!test_FileExt(fext, _T(".vbs.bas.vb.mac.qbt")) && !is_ini);

	return ret_str;
}

//---------------------------------------------------------------------------
//gqɑ΂֐p^[擾
//---------------------------------------------------------------------------
UnicodeString GetFunctionPtn(
	UnicodeString fext,			//gq
	UnicodeString &name_ptn,	//[o] O擾p^[
	bool isHtm2Txt)				//HTMLTEXTϊ
{
	UnicodeString func_ptn;
	name_ptn = EmptyStr;

	UnicodeString std_ptn = "\\b[_a-zA-Z]\\w*\\(";

	if (test_FileExt(fext, _T(".ahk"))) {
		func_ptn.USET_T("^[_a-zA-Z]\\w*\\(\\w*\\)\\s*{");
		name_ptn.USET_T("^[_a-zA-Z]\\w*\\(");
	}
	else if (test_FileExt(fext, _T(".au3"))) {
		func_ptn.USET_T("^Func\\s+[_a-zA-Z]\\w*\\(");
		name_ptn = std_ptn;
	}
	else if (test_FileExt(fext, FEXT_C_SH)) {
		func_ptn.USET_T("^([_a-zA-Z][^\\(=;:,]*[\\t ]+)*\\**([_a-zA-Z]\\w*::)?[~_a-zA-Z]\\w*\\([^;]*$");
		name_ptn.USET_T("(\\b|~)[_a-zA-Z]\\w*\\(");
	}
	else if (test_FileExt(fext, _T(".go"))) {
		func_ptn.USET_T("^func(\\s\\(.+\\))?\\s+[_a-zA-Z]\\w*");
		name_ptn = std_ptn;
	}
	else if (test_FileExt(fext, _T(".hsp"))) {
		func_ptn.USET_T("^#(defcfunc|deffunc)\\s+\\w+");
		name_ptn.USET_T("\\b\\w+\\b");
	}
	else if (test_FileExt(fext, _T(".js.jsx.as.awk"))) {
		func_ptn.USET_T("^function\\s+[_a-zA-Z]\\w*\\(");
		name_ptn = std_ptn;
	}
	else if (test_FileExt(fext, _T(".java"))) {
		func_ptn.USET_T("^\\s*((public|private|protected)\\s+)?[_a-zA-Z][^\\(=;:]*\\s+[_a-zA-Z]\\w*\\([^;]*$");
		name_ptn = std_ptn;
	}
	else if (test_FileExt(fext, _T(".kt.kts"))) {
		func_ptn.USET_T("^\\s*fun\\s+.+\\(.*\\)");
		name_ptn = std_ptn;
	}
	else if (test_FileExt(fext, _T(".lua"))) {
		func_ptn.USET_T("^(local\\s)?function\\s+[_a-zA-Z][\\w\\.:]*\\(");
		name_ptn = std_ptn;
	}
	else if (test_FileExt(fext, _T(".mac"))) {
		func_ptn.USET_T("^(sub|proc|function)\\s+[_a-zA-Z]\\w*");
	}
	else if (test_FileExt(fext, _T(".pas.dpr.dpk.inc"))) {
		func_ptn.USET_T("^(procedure|function)\\s+[_a-zA-Z]\\w*");
	}
	else if (test_FileExt(fext, _T(".php")) && !isHtm2Txt) {
		func_ptn.USET_T("^(function)\\s+[_a-zA-Z]\\w*");
	}
	else if (test_FileExt(fext, _T(".pl"))) {
		func_ptn.USET_T("^sub\\s+[_a-zA-Z]\\w*");
	}
	else if (test_FileExt(fext, _T(".ps1.psm1"))) {
		func_ptn.USET_T("^function\\s+[_a-zA-Z](\\w|-)*\\b");
		name_ptn.USET_T("\\s[_a-zA-Z](\\w|-)*\\b");
	}
	else if (test_FileExt(fext, _T(".rb.py")))
		func_ptn.USET_T("^\\s*def\\s+[_a-zA-Z]\\w*");
	else if (test_FileExt(fext, _T(".rs")))
		func_ptn.USET_T("^(pub\\s)?(fn)\\s+[_a-zA-Z]\\w*");
	else if (test_FileExt(fext, _T(".scala"))) {
		func_ptn.USET_T("^\\s*def\\s+[_a-zA-Z][^:]*:[^:]*");
		name_ptn.USET_T("\\b[_a-zA-Z]\\w*[\\(\\[:]");
	}
	else if (test_FileExt(fext, _T(".sh"))) {
		func_ptn.USET_T("^(function\\s)?[_a-zA-Z]\\w*\\(");
		name_ptn = std_ptn;
	}
	else if (test_FileExt(fext, _T(".swift"))) {
		func_ptn.USET_T("^\\s*func\\s+[_a-zA-Z]\\w*\\(");
		name_ptn = std_ptn;
	}
	else if (test_FileExt(fext, _T(".vbs.vb"))) {
		func_ptn.USET_T("^\\s*((public|private)\\s)?(shared\\s)?(sub|proc|function)\\s+[_a-zA-Z]\\w*");
	}

	return func_ptn;
}

//---------------------------------------------------------------------------
//\\`t@C擾
//---------------------------------------------------------------------------
UsrIniFile *GetHighlightFile(
	UnicodeString fnam,		//t@C
	UnicodeString &sct)		//[o] ZNV
{
	UsrIniFile *hl_file = NULL;
	sct = EmptyStr;

	UnicodeString hl_nam = ExtractFilePath(Application->ExeName) + "highlight.INI";
	if (file_exists(hl_nam)) {
		hl_file = new UsrIniFile(hl_nam);
		UnicodeString fext = get_extension(fnam);
		for (int i=0; i<hl_file->SectionList->Count; i++) {
			UnicodeString s = hl_file->SectionList->Strings[i];
			if (test_FileExt(fext, s)) {
				sct = s;  break;
			}
		}

		//ΏۃpX
		if (!sct.IsEmpty()) {
			TStringDynArray path_lst = split_strings_semicolon(hl_file->ReadString(sct, "TargetPath"));
			if (path_lst.Length>0) {
				bool ok = false;
				UnicodeString dnam = ExtractFilePath(fnam);
				for (int i=0; i<path_lst.Length && !ok; i++) {
					UnicodeString pnam = IncludeTrailingPathDelimiter(path_lst[i]);
					if (pnam.IsEmpty()) continue;
					if (StartsText(pnam, dnam)) ok = true;
				}
				if (!ok) sct = EmptyStr;
			}
		}

		if (sct.IsEmpty()) {
			delete hl_file;
			hl_file = NULL;
		}
	}

	return hl_file;
}
//---------------------------------------------------------------------------
